# $Revision: 1.88 $, $Date: 2010/07/29 08:04:36 $
#
# Conditional build:
%bcond_with	ssp	# disable stack-smashing protector 'coz dietlibc will not work with it!
#
Summary:	C library optimized for size
Summary(pl.UTF-8):	Biblioteka standardowa C zoptymalizowana na rozmiar
Summary(pt_BR.UTF-8):	libc pequena otimizada para tamanho
Name:		dietlibc
Version:	0.32
Release:	2
Epoch:		2
License:	GPL v2
Group:		Development/Libraries
Source0:	http://www.kernel.org/pub/linux/libs/dietlibc/%{name}-%{version}.tar.bz2
# Source0-md5:	0098761c17924c15e21d25acdda4a8b5
Patch0:		%{name}-ppc.patch
Patch1:		%{name}-opt.patch
Patch2:		%{name}-platform.patch
# workaround for http://gcc.gnu.org/PR26374
Patch3:		%{name}-gcc4.patch
Patch4:		%{name}-guard.patch
Patch5:		%{name}-arm.patch
Patch6:		%{name}-diet-m.patch
Patch7:		%{name}-nice.patch
Patch8:		%{name}-nostrip.patch
Patch9:		%{name}-stackgap-instead-of-ssp.patch
Patch10:	%{name}-fflush-null.patch
Patch11:	%{name}-_syscall-no-arch.patch
Patch12:	%{name}-noexecstacks.patch
Patch13:	%{name}-strcoll.patch
Patch15:	%{name}-memalign.patch
Patch16:	%{name}-getsubopt.patch
URL:		http://www.fefe.de/dietlibc/
BuildRequires:	rpmbuild(macros) >= 1.566
BuildRequires:	sed >= 4.0
%ifarch sparc sparcv9
BuildRequires:	sparc32
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		dietprefix	%{_prefix}/lib/dietlibc
# for some reason known only to rpm there must be "\\|" not "\|" here
%define		libarch		%(echo %{_target_cpu} | sed -e 's/i.86\\|pentium.\\|athlon/i386/;s/amd64/x86_64/;s/armv.*/arm/;s/sparcv.*/sparc/')

%description
Small libc for building embedded applications.

%description -l pl.UTF-8
Niewielka libc do budowania aplikacji wbudowanych.

%description -l pt_BR.UTF-8
A diet libc e' uma libc otimizada para criar pequenos binários
estaticamente linkados para Linux.

%package devel
Summary:	Development files for dietlibc
Summary(pl.UTF-8):	Pliki dla programistów używających dietlibc
Summary(pt_BR.UTF-8):	libc pequena otimizada para tamanho
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Small libc for building embedded applications - development files.

%description devel -l pl.UTF-8
Niewielka libc do budowania aplikacji wbudowanych - pliki dla
programistów.

%package static
Summary:	Static libraries for dietlibc
Summary(pl.UTF-8):	Biblioteki statyczne dla dietlibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Small libc for building embedded applications - static libraries.

%description static -l pl.UTF-8
Niewielka libc do budowania aplikacji wbudowanych - biblioteki
statyczne.

%prep
%setup -q
%undos arm/md5asm.S
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%{!?with_ssp:%patch9 -p1}
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch15 -p1
%patch16 -p1

%if "%{cc_version}" < "3.4"
%{__sed} -i -e '/CFLAGS/ s/-Wextra//' Makefile
%endif

%build
export OPTFLAGS="%{rpmcflags}%{?with_ssp: -fno-stack-protector} -fno-strict-aliasing"
%ifarch sparc sparcv9
sparc32 \
%endif
CC="%{__cc}"
%{__make} -j1 all \
	prefix=%{dietprefix} \
	CC="${CC#*ccache }"
%ifarch %{ix86}
%{__make} -j1 dyn \
	prefix=%{dietprefix} \
	CC="${CC#*ccache }"
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_bindir},%{_mandir}/man1}

%ifarch sparc sparcv9
sparc32 \
%endif
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	prefix=%{dietprefix}

mv $RPM_BUILD_ROOT%{dietprefix}/bin/* $RPM_BUILD_ROOT%{_bindir}
mv $RPM_BUILD_ROOT%{dietprefix}/man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
rm -rf $RPM_BUILD_ROOT%{dietprefix}/{bin,man}
rm -f $RPM_BUILD_ROOT%{_bindir}/diet-dyn

cat > $RPM_BUILD_ROOT%{_bindir}/%{_target_cpu}-dietlibc-gcc <<EOF
#!/bin/sh
exec %{_bindir}/diet gcc "\$@"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHOR BUGS CAVEAT CHANGES FAQ README THANKS TODO
%dir %{dietprefix}
%dir %{dietprefix}/lib-%{libarch}
%ifarch %{ix86}
%attr(755,root,root) %{dietprefix}/lib-%{libarch}/*.so
%{_sysconfdir}/diet.ld.conf
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*-dietlibc-gcc
%attr(755,root,root) %{_bindir}/diet
%attr(755,root,root) %{_bindir}/dnsd
%attr(755,root,root) %{_bindir}/elftrunc
%{dietprefix}/lib-%{libarch}/*.o
%{dietprefix}/include
%{_mandir}/man1/diet.1*

%files static
%defattr(644,root,root,755)
%{dietprefix}/lib-%{libarch}/*.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: dietlibc.spec,v $
Revision 1.88  2010/07/29 08:04:36  glen
- AC-fixes, ccache fixes

Revision 1.87  2009/07/19 07:31:28  arekm
- release 2

Revision 1.86  2009/06/28 20:17:00  patrys
- 0.32
- dropped cvs patch (merged upstream)

Revision 1.85  2009/06/04 07:25:32  arekm
- rel 7

Revision 1.84  2009/05/29 22:45:54  tommat
- sparcv9 support

Revision 1.83  2009/03/19 15:15:07  baggins
- rel 6
- added getsubopt(), memalign() and valloc()

Revision 1.82  2009/03/18 13:42:30  baggins
- untar first, dos2unix second

Revision 1.81  2009/03/18 13:32:50  baggins
- BR dos2unix

Revision 1.80  2009/03/18 13:28:58  baggins
- rel 5
- updated to CVS from 2009-03-17
- do not remove include/{asm,linux}, they are special stripped diet headers

Revision 1.79  2008/06/19 06:40:38  arekm
- rel 4

Revision 1.78  2008-01-27 23:38:45  qboosh
- non-executable *.o
- more verbose files

Revision 1.77  2007-10-09 15:31:11  baggins
- s/enviroment/environment/

Revision 1.76  2007/09/29 13:09:15  areq
- make -j1

Revision 1.75  2007/09/05 12:21:48  baggins
- rel 2

Revision 1.74  2007/09/03 20:04:46  qboosh
- updated to 0.31
- updated noexecstacks patch

Revision 1.73  2007/06/14 10:17:36  arekm
- fix strcoll on sparc

Revision 1.72  2007/02/12 21:23:53  glen
- tabs in preamble

Revision 1.71  2007/02/12 00:48:45  baggins
- converted to UTF-8

Revision 1.70  2007/02/06 21:28:53  arekm
- rel 4; more fixes from gentoo

Revision 1.69  2006/12/31 12:11:25  qboosh
- changed diet prefix to %{_prefix}/lib/dietlibc, now -m32/-m64 really work
- release 3

Revision 1.68  2006/12/31 00:22:52  qboosh
- updated opt patch to have effect not only on x86

Revision 1.67  2006/12/30 22:14:21  qboosh
- added diet-m patch (extends -m{32,64} handling in diet wrapper)
- BR: sparc32 on 32-bit sparc targets

Revision 1.66  2006/10/06 11:48:14  tommat
- more arm support

Revision 1.65  2006/10/06 10:30:17  tommat
- added dietlibc-arm.patch for more arm archs

Revision 1.64  2006/07/22 15:59:44  pluto
- release 2.

Revision 1.63  2006/07/19 23:08:32  qboosh
- added guard patch (fixes libc.so build on i386)

Revision 1.62  2006/07/12 14:28:32  pluto
- comment for gcc patch.

Revision 1.61  2006/07/12 14:11:03  sparky
- patch for 'libm/gamma.c:50: error: initializer element is not constant'
  still needed

Revision 1.60  2006/06/30 21:55:54  arekm
- up to 0.30

Revision 1.59  2005/12/27 12:28:28  qboosh
- release 2

Revision 1.58  2005/11/14 10:35:28  qboosh
- use proper CC

Revision 1.57  2005/07/24 11:41:49  pluto
- athlon,amd64,pentiumX patches merged.

Revision 1.56  2005/05/22 20:23:55  qboosh
- sparc .div/.rem already in sources, no need to generate in spec

Revision 1.55  2005/05/22 20:10:58  qboosh
- updated to 0.29, updated ppc,opt,gcc4 patches

Revision 1.54  2005/03/21 22:48:33  mmazur
- rel 2 for th

Revision 1.53  2005/02/11 01:48:29  pluto
- gcc4 fixes.

Revision 1.52  2005/02/09 18:58:30  darekr
- 0.28
- removed obsoleted patch, sorted files in %%doc

Revision 1.51  2004/08/27 16:02:24  pluto
- typo.

Revision 1.50  2004/08/18 21:27:02  pluto
- __i686-related build error fixed.

Revision 1.49  2004/07/31 00:47:41  qboosh
- updated to 0.27, removed obsolete gcc34 patch

Revision 1.48  2004/05/17 12:27:44  pluto
- all bconds fixed.

Revision 1.47  2004/05/17 12:08:43  pluto
- bcond: s/pp/ssp/

Revision 1.46  2004/04/20 13:25:14  pluto
- gcc 3.4 fixes.
- libarch macro simplified.

Revision 1.45  2004/04/20 10:53:38  cieciwa
- added Pentium4 macro [by PawciooS].

Revision 1.44  2004/04/15 08:51:51  pluto
- pentium 3/4 support.

Revision 1.43  2004/03/27 13:02:29  areq
- 0.25

Revision 1.42  2004/02/26 07:51:20  pluto
- pentium3 fix, strict deps.

Revision 1.41  2004/01/08 18:38:18  kosmo
- added %bcond_with pp (thx. Pawel Sikora)

Revision 1.40  2004/01/03 02:07:13  qboosh
- added specially tuned divrem.m4, generate missing sdiv.S and srem.S on sparc
- release 4

Revision 1.39  2004/01/02 16:13:03  jajcus
- Release: 3 (STBR after AMD64 fixes)

Revision 1.38  2003/12/19 13:14:12  jajcus
- amd64 support

Revision 1.37  2003/11/22 17:26:02  qboosh
- one more fix in ppc patch; release 2

Revision 1.36  2003/11/22 13:19:20  areq
- 0.24

Revision 1.35  2003/10/05 14:43:35  qboosh
- added athlon patch (fixes diet program on athlon)
- release 2

Revision 1.34  2003/09/13 10:59:55  areq
- 0.23
- remove outdated xdrmem-overflow.patch

Revision 1.33  2003/08/29 20:42:53  undefine
- fix build on sparc, release 4

Revision 1.32  2003/08/29 13:32:09  qboosh
- added patch for possible integer overflow in xdrmem functions
  (CAN-2003-0028, BTS#627)
- release 3

Revision 1.31  2003/08/18 08:08:00  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.30  2003/08/11 20:44:53  ankry
cosmetics

Revision 1.29  2003/07/20 17:08:47  areq
- Release:        2, rebuild

Revision 1.28  2003/07/08 00:05:11  blues
- second part of small fixes inspired by kloczek (this time better checked,
  I hope...)

Revision 1.27  2003/06/27 13:10:45  mmazur
- mass commit; now req: name = epoch:version

Revision 1.26  2003/05/26 16:24:53  malekith
- massive attack: adding Source-md5

Revision 1.25  2003/05/25 05:46:48  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.24  2003/02/20 19:28:01  areq
- 0.22

Revision 1.23  2002/10/05 12:41:29  areq
- 0.21, STBR

Revision 1.22  2002/08/25 16:22:40  qboosh
- build different versions for i[356]86
- opt patch - don't force -march=i386 on x86 (let optflags work)

Revision 1.21  2002/08/23 08:32:40  marcus
- new version 0.20
- dynamic linker is only for ix86

Revision 1.20  2002/08/07 02:20:30  kloczek
- run %build in sparc32 environment on sparc/sparcv9,
- remove gzipping %doc.

Revision 1.19  2002/08/06 19:58:22  marcus
- new version 0.19 (dynlinker on ppc still not ready)
- use new %%doc

Revision 1.18  2002/08/06 18:20:30  marcus
- start upgrade to 0.18

Revision 1.17  2002/06/10 16:48:10  kloczek
- realy releas 2 :)

Revision 1.16  2002/06/10 14:21:08  malekith
- -static requires -devel
- release 2

Revision 1.15  2002/05/12 20:58:57  marcus
- revert last change

Revision 1.14  2002/05/11 19:53:54  marcus
- added ExclusiveArch: due to: libdl/_dl_rel.h:22: #error "_dl_rel.h: NOT SUPPORTED"
on PPC
- rel.2.

Revision 1.13  2002/05/11 10:47:22  kloczek
- updated to 0.17 and merge translations from Conectiva.

Revision 1.12  2002/04/25 16:11:55  arturs
fixed a small typo

Revision 1.11  2002/03/15 14:22:55  malekith
- source is .bz2 not .gz

Revision 1.10  2002/03/15 14:14:20  malekith
- upgraded to 0.15
- split into main/devel/static subpackages
- added %{_arch}-dietlibc-gcc wrapper

Revision 1.9  2002/02/22 23:28:48  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.8  2002/01/18 02:12:42  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.7  2001/11/21 14:56:16  qboosh
- adapterized, pl translations

Revision 1.6  2001/08/23 16:51:16  filon
- changed: make -> %%{__make}

Revision 1.5  2001/04/10 14:15:16  klakier
- cvs ver 20010410

Revision 1.4  2001/04/07 15:51:49  klakier
- added URL

Revision 1.3  2001/04/04 21:46:39  kloczek
- more fixes but still NYF.

Revision 1.2  2001/04/04 20:53:00  kloczek
- partialy rewrited and updated to 0.8.

Based on MDK spec file.
